import es
import time
import installlib
import gamethread
import advertlib
from datetime import timedelta

info = es.AddonInfo()
info.name = "No_Teamflash"
info.author = "Brainsucker"
info.version = "1.2.7"
info.url = "http://addons.eventscripts.com/addons/view/no_teamflash"
info.description = "Unblinds Teamflashed Players"

adv = advertlib.ChatAdvert('no_teamflash_info', 'This Server is running $colorNoTeamflash $colorVersion $color%s$color.' % info['version'])
adv.colors = ['#green', '#default', '#lightgreen', '#default']
adv.min_interval = timedelta(seconds=300)

# If you do not want an advert, set this Value to False
adv.enabled = True



#Open a new Dictionary
flashdict = {}
#Add new Key to the Dictionary. In this Key we will save the information if the player was already flashed by an opponent 
flashdict["is_flashed"] = {}
#In this Key we will save the informations from the last flash that was done on the server.
flashdict["current_flash"] = {}

def updatecheck():
	a = installlib.getInstaller("no_teamflash")
	
	
	status = a.update()
	
	if status == a.STATUS_SUCCESSFUL:
		es.dbgmsg(0, '[No Teamflash] Addon has been updated to Version %s.' % a.addon.currentversion)
	
	
def load():
	es.ServerVar(info.name, info.version).makepublic()
	
	updatecheck()
	
	
	
	
#This Event is triggered BEFORE the event flashbang_detonate.
def player_blind(ev):
	global flashdict
	userid = ev["userid"]
	now = time.time()
	flashduration = es.getplayerprop(userid, "CCSPlayer.m_flFlashDuration")
	if not flashdict["current_flash"].has_key(userid):
		flashdict["current_flash"][userid] = {}
	flashdict["current_flash"][userid]["lastflash"] = now
	flashdict["current_flash"][userid]["flashduration"] = flashduration

def flashbang_detonate(ev):
	global flashdict
	userid = ev["userid"]
	now = time.time()
	t = es.getplayerteam(userid)
	for x in flashdict["current_flash"].keys():
		newflashtime = flashdict["current_flash"][x]["flashduration"]
		if es.getplayerteam(x) == t:
			if x != userid:
				newflashtime = 0
				if flashdict["is_flashed"].has_key(x):
					if (now-flashdict["is_flashed"][x]["lastflash"]) < flashdict["is_flashed"][x]["flashduration"]:
						newflashtime = (flashdict["is_flashed"][x]["flashduration"] - (now-flashdict["is_flashed"][x]["lastflash"]))
				es.setplayerprop(x, "CCSPlayer.m_flFlashDuration", newflashtime)
		if newflashtime > 0:
			if not flashdict["is_flashed"].has_key(x):
				flashdict["is_flashed"][x] = {}
			flashdict["is_flashed"][x]["lastflash"] = flashdict["current_flash"][x]["lastflash"]
			flashdict["is_flashed"][x]["flashduration"] = newflashtime
	flashdict["current_flash"] = {}
	
			
def player_disconnect(ev):
	userid = ev["userid"]
	if flashdict["is_flashed"].has_key(userid):
		del flashdict["is_flashed"][userid]
	if flashdict["current_flash"].has_key(userid):
		del flashdict["current_flash"][userid]
		
def unload():
	global adv
	# Delete the Advert, when the addon is unloaded.
	adv.unregister()